<?
/*
evePHP: Classe para desenvolvimento PHP

-----------------------------------------------------

Desenvolvido por Everton da Rosa.
Licena GNU (www.gnu.org).

-----------------------------------------------------

evePHP  uma classe PHP com diversas funes que facilitam o desenvolvimento de aplicaes PHP
Verso 1.0 (21 de novembro de 2007)

Funes: criar tabela com paginao, ordenao e filtragem de resultados

Futuro: xtab: efeito sobre a linha com foco do mouse. Outras funes: validao e formatao de CPF, CNPJ, data, hora; tratamento de texto; manipulao de data e hora (somar, diferena, converso, etc);

Changelog:
24/11/2007:
- Verso inaugural da evePHP

Para detalhes e ajuda complementar, consulte http://www.php.net/manual/pt_BR/index.php (manual em portugus do PHP)
Tpicos recomendados:
- Classes e Objetos (PHP 5): http://www.php.net/manual/pt_BR/language.oop5.php
- Variveis: http://www.php.net/manual/pt_BR/language.variables.php

Caso faa correes, melhorias ou modificaes, favor contatar o desenvolvedor atravs do e-mail everton3x@gmail.com enviando o cdigo para atualizao da classe nos sites onde ela se encontra hospedada.

Para exemplo de uso, veja o arquivo evePHP.*.samples.php

Ao utilizar esta classe, por favor indique seu autor da seguinte forma:
-----------------------------------------------------
evePHP: Classe para desenvolvimento PHP

Desenvolvido por Everton da Rosa (everton3x@gmail.com).
Licena GNU (www.gnu.org).
-----------------------------------------------------

Ao utilizar cdigo baseado nesta classe, por favor referencie da seguinte forma:
-----------------------------------------------------
Baseado na classe evePHP: Classe para desenvolvimento PHP, desenvolvida por Everton da Rosa (everton3x@gmail.com) sob licena GNU (www.gnu.org).
-----------------------------------------------------

*/


class evePHP{
	function xtab($config){
		if(!is_array($config)){
			exit('evePHP::xtab: O parmetro de configurao no  vlido!');
		}
		if(!$config['serialized']){
			$sql = $config['sql'];
			$size = $config['size'];
			$start = 0;
			$order = '';
			if($config['xtabField'] != ''){
				$xtabField = $config['xtabField'];
			}else{
				$xtabField = $unserialized['xtabField'];
			}
			if($config['xtabSearch'] != ''){
				$xtabSearch = $config['xtabSearch'];
			}else{
				$xtabSearch = $unserialized['xtabSearch'];
			}
		}else{
			$unserialized = unserialize(stripcslashes(html_entity_decode($config['serialized'],ENT_QUOTES)));
			if($config['order'] != ''){
				$order = $config['order'];
			}else{
				$order = $unserialized['order'];
			}
			if($config['xtabField'] != ''){
				$xtabField = $config['xtabField'];
			}else{
				$xtabField = $unserialized['xtabField'];
			}
			if($config['xtabSearch'] != ''){
				$xtabSearch = $config['xtabSearch'];
			}else{
				$xtabSearch = $unserialized['xtabSearch'];
			}
			$sql = $unserialized['sql'];
			$size = $unserialized['size'];
			$start = $unserialized['start'];
		}
		
		if($xtabField == '' || $xtabSearch == ''){
			$where = '';
		}else{
			$where = ' and '.$xtabField.' like "'.$xtabSearch.'" ';
		}
		
		$sqltotal = $sql.' '.$where;//sql uzado para calcular o nmero de pginas
		$sqlpage = $sql.' '.$where.' '.$order.' limit '.$start.','.$size; //sql para pegar os dados da pgina
		
		//nesta seo  feita a pesquisa no banco de dados. Estou usando a classe eveQuery, porm voc pode modificar como voc quiser
		// aqui que ser utilizado $config[connection]
		require('eveQuery.php');
		$eveQuery = new eveQuery();
		$resource = $eveQuery->query($sqlpage,'mysql',$config['connection'],$config['connection']['db']); //executa a consulta . no mude o nome da varivel $resource
		$getpages = $eveQuery->query($sqltotal,'mysql',$config['connection'],$config['connection']['db']); //pesquisa o total de linhas para calcular as pginas
		//fim da parte de conexo e consulta
		
		$NumeroDeLinhasTotal = mysql_num_rows($getpages);//retorna o nmero de linhas total da tabela
		$NumeroDeLinhas = mysql_num_rows($resource);//retorna o nmero de linhas do resultado
		$NumeroDeCampos = mysql_num_fields($resource); //pega o nmero de campos do resultado
		$NumeroDePaginas = ceil($NumeroDeLinhasTotal/$size); //calcula o total de pginas
		
		$table = '<table id="xtabTable">'; //abre a tabela
		$table .= '<tr id="xtabHeadTR">'; //abre a linha do cabealho
		for($i = 0;$i < $NumeroDeCampos; $i++){//monta o cabealho da tabela
			if(!$unserialized['start']){$startthis = 0;}else{$startthis = $unserialized['start'];}//pega o incio da pgina
			$arraythispage = array(//array contendo os parmetros para a montagem da classificao da coluna
				'sql'			=>	$sql,
				'order'			=>	$order,
				'size'			=>	$size,
				'start'			=>	$startthis,
				'xtabField'		=>	$xtabField,
				'xtabSearch'	=>	$xtabSearch
			);
			$serializedthispage = htmlentities(serialize($arraythispage),ENT_QUOTES);//prepara $array para ser enviado por GET
			$field = $config['labels'][$i];
			$table .= '<th id="xtabHeadTH">'.$field.'&nbsp;<a href="?serialized='.$serializedthispage.'&order=order by '.mysql_field_name($resource,$i).' asc&xtabField='.$xtabField.'&xtabSearch='.$xtabSearch.'"  class="xtabHeadSortLinkIcon"><img src="'.$config['sort_az'].'" class="xtabHeadSortIcon"></a><a href="?serialized='.$serializedthispage.'&order=order by '.mysql_field_name($resource,$i).' desc&xtabField='.$xtabField.'&xtabSearch='.$xtabSearch.'" class="xtabHeadSortLinkIcon"><img src="'.$config['sort_za'].'" class="xtabHeadSortIcon"></a></th>';//monta cada coluna do cabealho
		}
		$table .= '</tr>'; //fecha a linha do cabealho
		
		for($i = 0;$i < $NumeroDeLinhas; $i++){//monta o corpo da tabela
			$resto = $i%2; //verifica se a linha  par ou impar
			if($resto == 0){
				$classe = 'xtabBodyTrPar';
			}else{
				$classe = 'xtabBodyTrImpar';
			}
			
			$table .= '<tr class="'.$classe.'">'; //abre a linha
			for($h = 0;$h < $NumeroDeCampos;$h++){//monta as colunas de cada linha de resultado
				if(is_array($config['alink'])){
					$id = mysql_result($resource,$i,$config['alink'][0]);
					$alink = str_replace('[+value+]',$id,$config['alink'][1]);
				}else{
					$alink = '';
				}
				
				$table .= '<td class="xtabBodyTD"><a class="xtabBodyTDLink" '.$alink.'>'.mysql_result($resource,$i,$h).'</a></td>';//monta cada coluna da linha de resultado
			}
			$table .= '</tr>';//fecha a linha
		}
				
		$table .= '</table>'; //fecha a tabela
		
		$search = '<div id="xtabSearch"><div id="xtabDivFormSearch"><form id="xtabFormSearch" method="get">
		<label>Pesquisar</label>
		<input id="xtabFormSearchString" type="text" name="xtabSearch" value="'.$xtabSearch.'">
		<select id="xtabFormSearchFields" name="xtabField">'; //inicia o formulrio de pesquisa
		
		for($i = 0;$i < $NumeroDeCampos; $i++){//coloca os campos para procura
			if(mysql_field_name($resource,$i) == $xtabField){
				$selected = 'selected';
			}else{
				$selected = '';
			}
			$field = $config['labels'][$i];
			$search .= '<option value="'.mysql_field_name($resource,$i).'" '.$selected.'>'.$field.'</option>';
		}
		
		$search .= '</select><input id="xtabFormSearchSubmit" type="submit" value="Procurar">
		</form></div></div>'; //fecha o formulrio de pesquisa
		
		$footer = '<div id="xtabFooter">';//inicia o rodap
		$PaginaAtual = ceil($startthis/$size)+1;
		$ProximaPagina = $startthis+$size;
		$PaginaAnterior = $startthis-$size;
		$PrimeiraPagina = 0;
		$UltimaPagina = $NumeroDeLinhasTotal-($NumeroDeLinhasTotal%$size);
		
		$array = array(//array contendo os parmetros para a montagem da tabela
				'sql'			=>	$sql,
				'order'			=>	$order,
				'size'			=>	$size,
				'start'			=>	$PrimeiraPagina,
				'xtabField'		=>	$xtabField,
				'xtabSearch'	=>	$xtabSearch
			);
		$serialized = htmlentities(serialize($array),ENT_QUOTES);//prepara $array para ser enviado por GET
		$footer .= '<a class="xtabFooterLinkButtons" href="?serialized='.$serialized.'&order='.$order.'&xtabField='.$xtabField.'&xtabSearch='.$xtabSearch.'"><img class="xtabFooterButtons" src="'.$config['start'].'"></a>';
		
		$array = array(//array contendo os parmetros para a montagem da tabela
				'sql'			=>	$sql,
				'order'			=>	$order,
				'size'			=>	$size,
				'start'			=>	$PaginaAnterior,
				'xtabField'		=>	$xtabField,
				'xtabSearch'	=>	$xtabSearch
			);
		$serialized = htmlentities(serialize($array),ENT_QUOTES);//prepara $array para ser enviado por GET
		$footer .= '<a calss="xtabFooterLinkButtons" href="?serialized='.$serialized.'&order='.$order.'&xtabField='.$xtabField.'&xtabSearch='.$xtabSearch.'"><img class="xtabFooterButtons" src="'.$config['back'].'"></a>';
		
		for($i = 0;$i < $NumeroDePaginas; $i++){//monta o rodap da tabela
			$p = $i+1;//cria o nmero da pgina
			$start = ($p*$size)-$size; //cria o ponto de incio para a proxima pgina
			$array = array(//array contendo os parmetros para a montagem da tabela
				'sql'			=>	$sql,
				'order'			=>	$order,
				'size'			=>	$size,
				'start'			=>	$start,
				'xtabField'		=>	$xtabField,
				'xtabSearch'	=>	$xtabSearch
			);
			$serialized = htmlentities(serialize($array),ENT_QUOTES);//prepara $array para ser enviado por GET
			
			if($p == $PaginaAtual){
				$footer .= '&nbsp;<span class="xtabFooterThisPage">&nbsp;'.$p.'&nbsp;</span>&nbsp;';
			}else{
				$footer .= '&nbsp;&nbsp;<a class="xtabFooterOtherPage" href="?serialized='.$serialized.'&order='.$order.'&xtabField='.$xtabField.'&xtabSearch='.$xtabSearch.'">'.$p.'</a>&nbsp;&nbsp;';
			}
		}
		
		$array = array(//array contendo os parmetros para a montagem da tabela
				'sql'			=>	$sql,
				'order'			=>	$order,
				'size'			=>	$size,
				'start'			=>	$ProximaPagina,
				'xtabField'		=>	$xtabField,
				'xtabSearch'	=>	$xtabSearch
			);
		$serialized = htmlentities(serialize($array),ENT_QUOTES);//prepara $array para ser enviado por GET
		$footer .= '<a class="xtabFooterLinkButtons" href="?serialized='.$serialized.'&order='.$order.'&xtabField='.$xtabField.'&xtabSearch='.$xtabSearch.'"><img class="xtabFooterButtons" src="'.$config['forward'].'"></a>';
		
		$array = array(//array contendo os parmetros para a montagem da tabela
				'sql'			=>	$sql,
				'order'			=>	$order,
				'size'			=>	$size,
				'start'			=>	$UltimaPagina,
				'xtabField'		=>	$xtabField,
				'xtabSearch'	=>	$xtabSearch
			);
		$serialized = htmlentities(serialize($array),ENT_QUOTES);//prepara $array para ser enviado por GET
		$footer .= '<a class="xtabFooterLinkButtons" href="?serialized='.$serialized.'&order='.$order.'&xtabField='.$xtabField.'&xtabSearch='.$xtabSearch.'"><img class="xtabFooterButtons" src="'.$config['finish'].'"></a>';
		
		$footer .= '<a class="xtabFooterLinkButtons" href="'.$_SERVER['SCRIPT_NAME'].'"><img class="xtabFooterButtons" src="'.$config['clear'].'"></a>';
		
		$footer .= '</div>';//fecha o rodap
		
		$table = $search.$footer.$table; //acrescenta o formulrio de pesquisa e as pginas no topo
		$table .= $footer;//acrescenta o rodap  tabela
		$table = '<div id="xtabMainDiv">'.$table.'</div>';//insere a tabela num div
		return $table; //retorna o resultado da funo
	}
}
?>